//
//  SQLDriver.h
//  WeatherCat SQL Driver
//
//  Created by Stuart Ball on 3/4/2013
//

#import <Cocoa/Cocoa.h>
#import "WeatherCatPlugInProtocol.h"
#import "SQLUpdateThread.h"

//@class WeatherBugUpdateThread;
@class SQLPrefsWindow;
@interface SQLDriver : NSObject <WeatherCatPlugInProtocol>
{
    AppPlugInManagerAPI* myWeatherCat;  
    int uploadDelayCounter;
    NSPort* myPort; //Our worker thread port
    SQLUpdateThread* myUpdateThread;    //Our worker thread
	SQLPrefsWindow* myWindow;   //Our window
    BOOL run_state_copy; //Cached copy of the current run state (current_update_state) so when asked, we don't have to go talk to the thread to find out
}

-(AppPlugInManagerAPI*) getWeatherCat;

-(void)updateWindowWithState:(int)state packets_sent:(int)good_count packets_not_acked:(int)bad_count sent:(int)bytes_sent time_sent:(NSTimeInterval) SentTime av_time:(NSTimeInterval) av_time;
-(void) SetRunState:(BOOL) run_state;    
-(int) getRunState;

-(void) setCurrentState:(current_update_state) state;
-(current_update_state) getCurrentState;
-(void) resetTimings;
-(NSWindow*) getWindow;
-(void) setUploadString:(NSString*) string;
-(void) setUploadProgressIndicator:(BOOL)display value:(double)value max_value:(double)max_value;
@end
