//
//  PrefsWindow.h
//  WeatherBug
//
//  Created by Stuart Ball on 07/05/2013.
//  Copyright (c) 2013 Trixology. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "WeatherCatPlugInProtocol.h"
#import "SQLDriver.h"
#import "SQLUpdateThread.h"

@interface SQLPrefsWindow : NSWindowController
{
	IBOutlet id password; 
	IBOutlet id SQLPort; 
	IBOutlet id SQLURL;
    IBOutlet id DBName;
    IBOutlet id UserName;
     
	IBOutlet id updateRateFast; 
	IBOutlet id updateRateStepperFast;
     
	IBOutlet id updateRateDivider; 
	IBOutlet id updateRateStepperDivider; 

	IBOutlet id historicalUpdateRate; 
	IBOutlet id historicalUpdateRateStepper; 

	IBOutlet id reportsSent; 
	IBOutlet id acknowledgments; 

	IBOutlet id successRate; 
	IBOutlet id responseTime; 
	IBOutlet id bytesSent; 
	IBOutlet id currentStatus; 
	IBOutlet id otherDataTime; 
	IBOutlet id uploadString; 
	IBOutlet id uploadProgressIndicator; 

	IBOutlet id startButton; 
	IBOutlet id stopButton; 

    SQLDriver* myController;
    AppPlugInManagerAPI* myAPIManager;
    float max_time;
    float min_time;
    BOOL last_progress_view_state;
}
- (IBAction)handlePrefs:(id)sender;
- (IBAction)handleTimingReset:(id)sender;

-(void) setMyController:(SQLDriver*) controller APIManager:(AppPlugInManagerAPI*) APIManager;
-(void)updateWithState:(int)state packets_sent:(int)good_count packets_not_acked:(int)bad_count sent:(int)bytes_sent time_sent:(NSTimeInterval) SentTime av_time:(NSTimeInterval) av_time;
-(void) updateRunningUploadState:(current_update_state) current_state;
-(void) setMiscString:(NSString*) string;
-(void) setUploadProgressIndicator:(BOOL)display value:(double)value max_value:(double)max_value;

@end
