//
//  SQLPrefsWindow.m
//  SQLDriver
//
//  Created by Stuart Ball on 07/05/2013.
//  Copyright (c) 2013 Trixology. All rights reserved.
//

#import "SQLPrefsWindow.h"
@interface SQLPrefsWindow ()

@end

@implementation SQLPrefsWindow

- (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    if (self) {
        // Initialization code here.
    }
    min_time=1000000;
    return self;
}

- (void)windowDidLoad
{
    [super windowDidLoad];
    
    // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
}

- (void)awakeFromNib
{
    [self updatePrefs];
    int current_state=[myController getCurrentState];
    [uploadProgressIndicator setHidden:YES];
    [uploadProgressIndicator setUsesThreadedAnimation:YES];
    [uploadProgressIndicator setDoubleValue:0.0];
    [self updateWithState:current_state packets_sent:0 packets_not_acked:0 sent:0 time_sent: 0 av_time:0];

}

-(void) setMyController:(SQLDriver*) controller APIManager:(AppPlugInManagerAPI*) APIManager
{
	myController=controller;
	myAPIManager=APIManager;
}

- (IBAction)handleTimingReset:(id)sender
{
    NSBundle* myBundle =[ NSBundle bundleForClass:[self class]];	//So we can get at localised strings

    max_time=0;
    min_time=999;
    [myController resetTimings];
    NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Resetting...", @"Localizable",myBundle, @"")];
    [responseTime setObjectValue:temp];		

   
}


//Deals with all interactions
- (IBAction)handlePrefs:(id)sender
{
	NSNumber* value;
	NSValue* switch_value;
	NSString *string_str;
    

    string_str=[password stringValue];  //Save the password
    {
        [myAPIManager setPassword:string_str forKey:@"SQLDriverPassword"];
    }
    

    string_str=[SQLPort stringValue];
    [[NSUserDefaults standardUserDefaults] setObject:string_str forKey:@"com.trixology.SQLDriver.Port"];

    string_str=[SQLURL stringValue];
    [[NSUserDefaults standardUserDefaults] setObject:string_str forKey:@"com.trixology.SQLDriver.URL"];

    string_str=[UserName stringValue];
    [[NSUserDefaults standardUserDefaults] setObject:string_str forKey:@"com.trixology.SQLDriver.UserName"];


    string_str=[DBName stringValue];
    [[NSUserDefaults standardUserDefaults] setObject:string_str forKey:@"com.trixology.SQLDriver.DBName"];

    switch_value=[updateRateFast objectValue];
    [[NSUserDefaults standardUserDefaults] setObject:switch_value forKey:@"com.trixology.SQLDriver.UploadPeriodInSecondsFast"];
    switch_value=[updateRateDivider objectValue];
    [[NSUserDefaults standardUserDefaults] setObject:switch_value forKey:@"com.trixology.SQLDriver.updateRateDivider"];

   switch_value=[historicalUpdateRate objectValue];
    [[NSUserDefaults standardUserDefaults] setObject:switch_value forKey:@"com.trixology.SQLDriver.historicalUpdatePeriod"];



	if ([sender tag]==100)
	{
		value=[sender objectValue];
		[updateRateFast setFloatValue:[value floatValue]]; 
		[updateRateStepperFast setFloatValue:[value floatValue]]; 
		switch_value=[updateRateFast objectValue];
		[[NSUserDefaults standardUserDefaults] setObject:switch_value forKey:@"com.trixology.SQLDriver.UploadPeriodInSecondsFast"];

	}

	if ([sender tag]==110)
	{
		value=[sender objectValue];
		[updateRateDivider setFloatValue:[value floatValue]]; 
		[updateRateStepperDivider setFloatValue:[value floatValue]]; 
		switch_value=[updateRateDivider objectValue];
		[[NSUserDefaults standardUserDefaults] setObject:switch_value forKey:@"com.trixology.SQLDriver.updateRateDivider"];

	}


	if ([sender tag]==120)
	{
		value=[sender objectValue];
		[historicalUpdateRate setFloatValue:[value floatValue]]; 
		[historicalUpdateRateStepper setFloatValue:[value floatValue]]; 
		switch_value=[historicalUpdateRate objectValue];
		[[NSUserDefaults standardUserDefaults] setObject:switch_value forKey:@"com.trixology.SQLDriver.historicalUpdatePeriod"];

	}




	//Start button
	if ([sender tag]==80)
	{
			NSString* URL_string=[[NSUserDefaults standardUserDefaults] stringForKey:@"com.trixology.SQLDriver.URL"];
			NSString* password_string=[myAPIManager getPasswordForKey:@"SQLDriverPassword"];
            
			NSString* port_string=[[NSUserDefaults standardUserDefaults] stringForKey:@"com.trixology.SQLDriver.Port"];
			
            if ([URL_string compare:@""]==NSOrderedSame)
			{
				return;	//No start if ID or pwd empty
			}
			if ([password_string compare:@""]==NSOrderedSame)
			{
				return;;
			}
			if ([port_string compare:@""]==NSOrderedSame)
			{
				return;	//No start if ID or pwd empty
			}

		[myController SetRunState:YES];
	}

	//Stop button
	if ([sender tag]==81)
	{
		[myController SetRunState:NO];
	}


    [self updatePrefs];
}

-(void) updatePrefs
{

 NSString* path=[[NSUserDefaults standardUserDefaults] stringForKey:@"com.trixology.SQLDriver.URL"];
 [SQLURL setObjectValue:path];

 path=[[NSUserDefaults standardUserDefaults] stringForKey:@"com.trixology.SQLDriver.UserName"];
 [UserName setObjectValue:path];

 
 int port=[[NSUserDefaults standardUserDefaults] integerForKey:@"com.trixology.SQLDriver.Port"];
 [SQLPort setIntegerValue:port];

 path=[myAPIManager getPasswordForKey:@"SQLDriverPassword"];
 [password setObjectValue:path];

    float seconds=[[NSUserDefaults standardUserDefaults] floatForKey:@"com.trixology.SQLDriver.UploadPeriodInSecondsFast"];
    [updateRateFast setFloatValue:seconds];
    [updateRateStepperFast setFloatValue:seconds];

    int divider=[[NSUserDefaults standardUserDefaults] floatForKey:@"com.trixology.SQLDriver.updateRateDivider"];
    [updateRateDivider setFloatValue:divider];
    [updateRateStepperDivider setFloatValue:divider];
    float otherDataUpdateTime=seconds*divider;
    NSString* temp=[NSString localizedStringWithFormat:@"(%.1f seconds)", otherDataUpdateTime];
    [otherDataTime setObjectValue:temp];		

    float historical_period=[[NSUserDefaults standardUserDefaults] floatForKey:@"com.trixology.SQLDriver.historicalUpdatePeriod"];
    [historicalUpdateRate setFloatValue:historical_period];
    [historicalUpdateRateStepper setFloatValue:historical_period];


    path=[[NSUserDefaults standardUserDefaults] stringForKey:@"com.trixology.SQLDriver.DBName"];
    [DBName setObjectValue:path];
    
    
    BOOL can_run=YES;
    if ([[password stringValue] length]==0)
    {
        can_run=NO;
        [myController setCurrentState:updater_no_password_error];
		[myController SetRunState:0];
    }
    if ([[SQLPort stringValue] length]<1)
    {
        can_run=NO;
        [myController setCurrentState:updater_no_port_error];
		[myController SetRunState:0];
    }
    if ([[SQLURL stringValue] length]<1)
    {
        can_run=NO;
        [myController setCurrentState:updater_no_url_error];
		[myController SetRunState:0];
    }

    if ([[UserName stringValue] length]<1)
    {
        can_run=NO;
        [myController setCurrentState:updater_no_user_error];
		[myController SetRunState:0];
    }
    
    if (can_run==YES)
	{
        
        if ([myController getRunState]==YES)    //Are we running
        {
            [stopButton setEnabled:1];
            [startButton setEnabled:0];
        }
        else
        {
            [startButton setEnabled:1];
            [stopButton setEnabled:0];
        }
	}
	else
	{
		[startButton setEnabled:0];
		[stopButton setEnabled:0];

	}
    
}



//This method updates us with the current upload state of the wunderground upload thread (called via the controller)
-(void)updateWithState:(int)state packets_sent:(int)good_count packets_not_acked:(int)bad_count sent:(int)bytes_sent time_sent:(NSTimeInterval) SentTime av_time:(NSTimeInterval) av_time
{
	current_update_state current_state=state;
	NSString* temp=[NSString localizedStringWithFormat:@"%i", good_count];
	[reportsSent setObjectValue:temp];
	temp=[NSString localizedStringWithFormat:@"%i", bad_count];
	[acknowledgments setObjectValue:temp];
	if (SentTime!=0)
	{
		NSTimeInterval time_now=[[NSDate date] timeIntervalSince1970];
		NSTimeInterval tx_time=time_now-SentTime;
        if (tx_time>max_time)
        {
            max_time=tx_time;
        }
        if (tx_time<min_time)
        {
            min_time=tx_time;
        }
		temp=[NSString localizedStringWithFormat:@"%.3f (Max: %.3f Av: %.3f Min: %.3f)", tx_time, max_time, av_time, min_time];
        [responseTime setObjectValue:temp];		
    }
    //else
    //{
    //    [responseTime setObjectValue:[NSString localizedStringWithFormat:NSLocalizedString (@"N/A", @"")]];
    //}
	if (bytes_sent>(1024*1024*1024))
	{
		temp=[NSString localizedStringWithFormat:@"%.3f GB", (float)bytes_sent/(1024*1024*1024)];
	}
	else
	if (bytes_sent>(1024*1024))
	{
		temp=[NSString localizedStringWithFormat:@"%.2f MB", (float)bytes_sent/(1024*1024)];
	}
	else
	if (bytes_sent>1024)
	{
		temp=[NSString localizedStringWithFormat:@"%.2f KB", (float)bytes_sent/1024];
	}
	else
	{
		temp=[NSString localizedStringWithFormat:@"%i", bytes_sent];
	}
	[bytesSent setObjectValue:temp];
    
    
	float quality=(( ( (float)bad_count /(float)good_count)*100.0));
	if (quality<0) quality=0;
    if (good_count==0)
    {
        [successRate setObjectValue:[NSString localizedStringWithFormat:NSLocalizedString (@"N/A", @"")]];
    }
    else
    {
        [successRate setObjectValue:[NSString localizedStringWithFormat:NSLocalizedString (@"%.2f%%", @""), quality]];
    }

	[self updateRunningUploadState:current_state];

}

-(void) updateRunningUploadState:(current_update_state) current_state
{
   NSBundle* myBundle =[ NSBundle bundleForClass:[self class]];	//So we can get at localised strings


	if (current_state==updater_disabled)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Disabled", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		//disable stop button
		[stopButton setEnabled:0];
		[startButton setEnabled:1];
	}
	else
	if (current_state==updater_ok)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Running", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}
	else
	if (current_state==updater_bad_data)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Data not ready - waiting...", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}
	else
	if (current_state==updater_transmitting)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Transmitting", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}
	else
	if (current_state==updater_waiting_to_start)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Waiting to start", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}
	else
	if (current_state==updater_waiting)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Waiting for response", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}
	else
	if (current_state==updater_receiving)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Receiving", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}
	else
	if (current_state==updater_populating)
	{
		NSString* temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Uploading missing data to database.", @"Localizable",myBundle, @"")];
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}

	else
	{
	NSString* temp;
		if (current_state==updater_error_could_not_transmit)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"No Connection", @"Localizable",myBundle, @"")];
		}
		else
		if ((current_state==updater_no_user_error) || (current_state==updater_pwd))
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Pwd/I.D. Error", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_no_url_error)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"No URL", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_no_password_error)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"No Password", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_reception_error)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Server busy/unavailable", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_no_response)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"No Response", @"Localizable",myBundle, @"")];
		}
		
		else
		if (current_state==updater_internet_down)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"No Internet?", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_error_no_reply)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"No Reply", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_unknown_db)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Database error (SQLErr: 1049)", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_sql_error)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"SQL Error - see log window", @"Localizable",myBundle, @"")];
		}
		else
		if (current_state==updater_cant_connect)
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"URL/Port Error", @"Localizable",myBundle, @"")];
		}
        
		else
		{
			temp=[NSString localizedStringWithFormat:NSLocalizedStringFromTableInBundle (@"Error", @"Localizable",myBundle, @"")];
		}
		[currentStatus setObjectValue:temp];
		[startButton setEnabled:0];
		[stopButton setEnabled:1];
	}
	
}


-(void) setMiscString:(NSString*) string
{
    [uploadString setObjectValue:string];
}

-(void) setUploadProgressIndicator:(BOOL)display value:(double)value max_value:(double)max_value
{
    if (display!=last_progress_view_state)
    {
        if (display==YES)
        {
                [uploadProgressIndicator setHidden:NO];
                [uploadProgressIndicator setMaxValue:(double)max_value];	//this many items to copy
                [uploadProgressIndicator setMinValue:0.0];	//this many items to copy
                [uploadProgressIndicator setDoubleValue:0.0];
        }
        else
        {
                [uploadProgressIndicator setHidden:YES];
        }
        last_progress_view_state=display;
    }
    [uploadProgressIndicator setDoubleValue:value];
}

@end
