//
//  SQLUpdateThread.h
//  SQLDriver
//
//  Created by Stuart Ball on 06/05/2013.
//  Copyright (c) 2013 Trixology. All rights reserved.
//

#include "mysql.h"
@class SQLDriver;
@class AppPlugInManagerAPI;
typedef enum {

updater_disabled=100,
updater_waiting_to_start=199,
updater_ok=200,
updater_transmitting=210,
updater_receiving=211,
updater_waiting=212,
updater_bad_data=400,
updater_no_url_error=500,
updater_no_port_error=501,
updater_no_password_error=510,
updater_no_user_error=520,
updater_bad_station_id_error=530,
updater_unknown_db=600,
updater_sql_error=601,  //See the log window for details
updater_cant_connect=602, 
updater_reception_error=700,
updater_no_response=710,
updater_error_no_reply=711,
updater_error_could_not_transmit=712,
updater_pwd=720,
updater_populating=730,
updater_internet_down=800,
updater_error=990,  
} current_update_state; //various internal states we can report to the user

typedef enum 
{
   MYSQL_OK, ///<Success
   MYSQL_PROCESSING, ///<Processing
   MYSQL_PRTCL, ///<Protocol error
   MYSQL_SETUP, ///<Not properly configured
   MYSQL_DNS, ///<Could not resolve name
   MYSQL_AUTHFAILED, ///<Auth failure
   MYSQL_READY, ///<Ready to send commands
   MYSQL_SQL, ///<SQL Error
   MYSQL_TIMEOUT, ///<Connection timeout
   MYSQL_CONN ///<Connection error
}MySQLResult;

@interface SQLUpdateThread : NSObject
{
    SQLDriver* myController;
    BOOL thread_stop;
    NSPort* distantPort;
    NSTimer* RunTimer;
    NSTimer* AnswerTimer;   //used to time the in-flight time
    BOOL upload_in_progress;    //Stops us trying to uplaod if we are already uploading
    current_update_state current_state;  //one of current_update_state

	NSTimeInterval SentTime;    //the time we started talking to the server (used to provide the in-flight time)
    int sent_packets;
    int ack_packets;
	int data_sent_length;
    int bytes_sent;
    
	NSTimeInterval AverageTime;
	NSTimeInterval CumulativeFlightTime;

    AppPlugInManagerAPI* myAPIManager;
    int update_rate_in_secs;    //how many seconds between updates

// -----------------------Internet stuff
	
    int sql_error;
    MySQLResult internal_sql_error;
    BOOL checked_tables;
    int slow_update_counter;    //divider to update the slow data
    
// --------------------SQL stuff

    MYSQL *con;
    BOOL tables_exist;  //If it's a new database, ask the user if they wnat to populate with their WeatherCat data
}


-(void) setup:(SQLDriver *)value ;
- (void)updateThreadMethod:(id)anObject;
-(void) SetRunState:(BOOL) run_state;
-(void) setCurrentState:(current_update_state) state;
-(current_update_state) getCurrentState;
-(void) doUpdatePrefs;
-(void) resetTable;
-(void) resetTimings;
-(void) quit;
@end
